<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
    <meta name="GENERATOR" content="Quadralay WebWorks Publisher Professional Edition 6.0.7" />
    <meta name="TEMPLATEBASE" content="DataDirect WWH 2.0" />
    <meta name="LASTUPDATED" content="09/05/02 10:40:34" />
    <title>Using Database Metadata Methods</title>
    <link rel="StyleSheet" href="document.css" type="text/css" media="screen" />
  </head>

  <body>
    <script type="text/javascript" language="JavaScript">
     <!--
      function  WWHUpdateFavorite(ParamHREF)
      {
        if ((parent != null) &&
            (parent.WWHelpFrameSet != null))
        {
          parent.WWHelpFrameSet.fUpdateFavorite(ParamHREF);
        }
      }

      function  WWHSyncTOC(ParamHREF)
      {
        if ((parent != null) &&
            (parent.WWHelpFrameSet != null))
        {
          parent.WWHelpFrameSet.fSyncTOC(ParamHREF);
        }
      }

      function  WWHShowPopup(ParamContext,
                             ParamLink,
                             ParamEvent)
      {
        if ((parent != null) &&
            (parent.WWHelpFrameSet != null))
        {
          parent.WWHelpFrameSet.fShowPopup(ParamContext, ParamLink, ParamEvent);
        }
      }

      function  WWHHidePopup()
      {
        if ((parent != null) &&
            (parent.WWHelpFrameSet != null))
        {
          parent.WWHelpFrameSet.fHidePopup();
        }
      }

      function  WWHClickedPopup(ParamContext,
                                ParamLink)
      {
        if ((parent != null) &&
            (parent.WWHelpFrameSet != null))
        {
          location.href = parent.WWHelpFrameSet.fClickedPopup(ParamContext, ParamLink);
        }
      }
     // -->
    </script>

    <script type="text/javascript" language="JavaScript">
     <!--
      var  WWHelpHREF = location.href;


      WWHUpdateFavorite(WWHelpHREF);
     // -->
    </script>

    <blockquote>
<h2 id="72256" class="NewHTMLPage">
  <a name="72256"> </a>Using Database Metadata Methods
</h2><hr />
<p id="72284" class="Body">
  <a name="72284"> </a>Because database metadata methods that generate Resultset objects are slow compared to other JDBC methods, their frequent use can impair system performance. The guidelines in this section will help you to optimize system performance when selecting and using database metadata.
</p>
<h3 id="72285" class="Heading2">
  <a name="72285"> </a>Minimizing the Use of Database Metadata Methods
</h3>
<p id="72286" class="Body">
  <a name="72286"> </a>Compared to other JDBC methods, database metadata methods that generate Resultset objects are relatively slow. Applications should cache information returned from result sets that generate database metadata methods so that multiple executions are not needed.
</p>
<p id="72260" class="Body">
  <a name="72260"> </a>While almost no JDBC application can be written without database metadata methods, you can improve system performance by minimizing their use. To return all result column information <em>mandated</em> by the JDBC specification, a JDBC driver may have to perform complex queries or multiple queries to return the necessary result set for a single call to a database metadata method. These particular elements of the SQL language are performance-expensive. 
</p>
<p id="72261" class="Body">
  <a name="72261"> </a>Applications should cache information from database metadata methods. For example, call getTypeInfo once in the application and cache away the elements of the result set that your application depends on. It is unlikely that any application uses all elements of the result set generated by a database metadata method, so the cache of information should not be difficult to maintain.
</p>
<h3 id="72262" class="Heading2">
  <a name="72262"> </a>Avoiding Search Patterns
</h3>
<p id="72263" class="Body">
  <a name="72263"> </a>Using null arguments or search patterns in database metadata methods results in generating time-consuming queries. In addition, network traffic potentially increases due to unwanted results. Always supply as many non-null arguments to result sets that generate database metadata methods as possible.
</p>
<p id="72264" class="Body">
  <a name="72264"> </a>Because database metadata methods are slow, applications should invoke them as efficiently as possible. Many applications pass the fewest non-null arguments necessary for the function to return success.
</p>
<p id="72265" class="Body">
  <a name="72265"> </a>For example:
</p>
<pre  class="Preformatted">
ResultSet WSrs = WSc.getTables (null, null, &quot;WSTable&quot;, null);<a name="72266"> </a>
</pre>
<p id="72267" class="Body">
  <a name="72267"> </a>should be:
</p>
<pre  class="Preformatted">
ResultSet WSrs = WSc.getTables (&quot;cat1&quot;, &quot;johng&quot;, &quot;WSTable&quot;, &quot;TABLE&quot;);<a name="72268"> </a>
</pre>
<p id="72224" class="Body">
  <a name="72224"> </a>Sometimes, little information is known about the object for which you are requesting information. Any information that the application can send the driver when calling database metadata methods can result in improved performance and reliability. 
</p>
<h3 id="72332" class="Heading2">
  <a name="72332"> </a>Using a Test Query to Determine Table Characteristics
</h3>
<p id="72333" class="Body">
  <a name="72333"> </a>Avoid using getColumns to determine characteristics about a table. Instead, use a test query with getMetadata.
</p>
<p id="72334" class="Body">
  <a name="72334"> </a>Consider an application that allows the user to choose the columns that will be selected. Should the application use getColumns to return information about the columns to the user or instead prepare a test query and call getMetadata?
</p>
<h4 id="72336" class="Heading3">
  <a name="72336"> </a>Case 1: GetColumns Method
</h4>
<pre  class="Preformatted">
ResultSet WSrc = WSc.getColumns (... &quot;UnknownTable&quot; ...);<a name="72337"> </a>
// This call to getColumns will generate a query to <a name="72338"> </a>
// the system catalogs... possibly a join<a name="72339"> </a>
// which must be prepared, executed, and produce<a name="72340"> </a>
// a result set<a name="72341"> </a>
. . .    <a name="72342"> </a>
WSrc.next();<a name="72343"> </a>
string Cname = getString(4);<a name="72344"> </a>
. . .    <a name="72345"> </a>
// user must retrieve N rows from the server <a name="72346"> </a>
// N = # result columns of UnknownTable<a name="72347"> </a>
// result column information has now been obtained<a name="72348"> </a>
</pre>
<h4 id="72351" class="Heading3">
  <a name="72351"> </a>Case 2: GetMetadata Method
</h4>
<pre  class="Preformatted">
// prepare test query <a name="72352"> </a>
PreparedStatement WSps = WSc.prepareStatement 
    (... &quot;SELECT * from UnknownTable WHERE 1 = 0&quot; ...);<a name="72353"> </a>
// query is never executed on the server - <a name="72354"> </a>
// only prepared<a name="72355"> </a>
ResultSetMetaData WSsmd=wsps.getMetaData();<a name="72356"> </a>
int numcols = WSrsmd.getColumnCount();<a name="72357"> </a>
...<a name="72358"> </a>
int ctype = WSrsmd.getColumnType(n)<a name="72359"> </a>
...<a name="72360"> </a>
// result column information has now been obtained<a name="72361"> </a>
// Note we also know the column ordering within the <a name="72362"> </a>
// table!  This information cannot be<a name="72363"> </a>
// assumed from the getColumns example.<a name="72364"> </a>
</pre>
<p id="72365" class="Body">
  <a name="72365"> </a>In both cases, a query is sent to the server, but in Case 1 the query must be evaluated and form a result set that must be sent to the client. Clearly, Case 2 is the better performing model. 
</p>
<p id="72505" class="Body">
  <a name="72505"> </a>To somewhat complicate this discussion, let us consider a DBMS server that does not natively support preparing a SQL statement. The performance of Case 1 does not change but Case 2 increases minutely because the test query must be evaluated instead of only prepared. Because the Where clause of the query always evaluates to FALSE, the query generates no result rows and should execute without accessing table data. For this situation, method 2 still outperforms method 1.
</p>
    </blockquote>

    <hr />

    <table border="0">
      <tr>
        <td width="23">
<a href="jdbcdesign.html">
      <img alt="Previous Document" border="0" src="images/prev.gif" width="23" height="21" />
    </a>
        </td>
        <td width="23" class="CellBody">
        Previous Page       
        </td>
        <td width="23">
<a href="jdbcdesign3.html">
      <img alt="Next Document" border="0" src="images/next.gif" width="23" height="21" />
    </a>
        </td>
        <td width="23" class="CellBody">
        Next Page       
        </td>
        <td width="23">
          <a href="javascript:WWHSyncTOC(WWHelpHREF);">
            <img alt="Synchronize TOC" border="0" src="images/sync.gif" width="23" height="21" />
          </a>
        </td>
        <td width="120" class="CellBody">
        Synchronize with Contents
        </td>
      </tr>
    </table>

   <div id="WWHelpPopupDIV" style="position: absolute ; z-index: 1 ; visibility: hidden ; top: 0px ; left: 0px">
    <script type="text/javascript" language="JavaScript">
     <!--
      if ((parent != null) &&
          (parent.WWHelpFrameSet != null))
      {
        if (document.all != null)  // Non-Netscape browser
        {
          document.writeln(parent.WWHelpFrameSet.mPopup.fFormat("Popup"));
        }
      }
     // -->
    </script>
   </div>
  </body>
</html>
